globales
  limite, aux: entero;
  criba: vector[100] de entero;
fin


// Devuelve 1 si n es un número primo y 0 si no lo es
funcion es_primo(n: entero) : entero
es
  locales
    divisor, primo: entero;
  fin
secuencia
  si n = 1 entonces
    primo := 0;
  si_no
    secuencia
      primo := 1;
      divisor := 2;
      repetir
        salir si divisor > n / 2;
        si n % divisor = 0 entonces
          primo := 0;
        si_no secuencia fin
        fin
        divisor := divisor + 1;
      hasta primo = 0;
    fin
  fin
  devuelve primo;
fin


// Muestra los números primos menores que N
funcion primos_menores(N: entero) : entero
es
  locales
    numero: entero;
  fin
secuencia
  escribe "Primos menores que "; escribe N; escribe ": ";
  numero := 1;
  repetir
    si llama es_primo(numero) = 1 entonces
      secuencia
        escribe numero; escribe " ";
      fin
    si_no secuencia fin
    fin
    numero := numero + 1;
  hasta numero >= N;
  nl;
  devuelve 0;
fin


// Muestra los números primos menores que N (N<100)
funcion primos_menores_criba(N: entero) : entero
es
  locales
    i, j, cont: entero;
  fin
secuencia
  // Inicializar vector
  criba[1] := 0;
  i := 2;
  repetir
    criba[i] := 1;
    i := i + 1;
  hasta i >= N;

  // Aplicar criba
  i := 2;
  repetir
    salir si i >= N;
    j := 2;
    si criba[i] = 1 entonces
      repetir
        salir si i * j >= N;
        criba[i*j] := 0;
        j := j + 1;
      hasta 1=0;
    si_no secuencia fin
    fin
    i := i + 1;
  hasta 1=0;

  // Mostrar primos encontrados
  escribe "Primos menores que "; escribe N; escribe ": ";
  i := 1;
  repetir
    si criba[i] = 1 entonces
      secuencia
        escribe i; escribe " ";
      fin
    si_no secuencia fin
    fin
    i := i + 1;
  hasta i >= N;
  nl;
  devuelve 0;
fin


// Muestra los N primeros números primos
funcion primeros_primos(N: entero) : entero
es
  locales
    numero, cantidad: entero;
  fin
secuencia
  escribe N; escribe " primeros primos: ";
  cantidad := 0;
  numero := 1;
  repetir
    si llama es_primo(numero) = 1 entonces
      secuencia
        escribe numero; escribe " ";
        cantidad := cantidad + 1;
      fin
    si_no secuencia fin
    fin
    numero := numero + 1;
  hasta cantidad >= N;
  nl;
  devuelve 0;
fin


// Programa principal
secuencia
  limite := 15;
  aux := llama primos_menores(limite);
  aux := llama primos_menores_criba(limite);
  aux := llama primeros_primos(limite);
fin
