globales
  matriz: vector[49] de vector[49] de entero;
  tam, i, j, aux: entero;
fin


// Rellena la variable global matriz con un cuadrado mágico NxN (N<50 e impar)
funcion crea_cuadrado_magico(N: entero) : entero
es
  locales
    fila, col, auxfila, auxcol, valor: entero;
  fin
secuencia
  // Inicializar la matriz con 0
  fila := 0;
  repetir
    col := 0;
    repetir
      matriz[fila][col] := 0;
      col := col + 1;
    hasta col >= N;
    fila := fila + 1;
  hasta fila >= N;

  fila := 0;
  col := N/2;
  matriz[fila][col] := 1;
  valor := 2;
  repetir
    salir si valor > N * N;
    auxfila := fila;
    auxcol := col;

    fila := fila - 1;
    si fila < 0 entonces
      fila := N-1;
    si_no secuencia fin
    fin

    col := col + 1;
    si col >= N entonces
      col := 0;
    si_no secuencia fin
    fin

    si matriz[fila][col] != 0 entonces
      secuencia
        fila := auxfila + 1;
        col := auxcol;
      fin
    si_no secuencia fin
    fin

    matriz[fila][col] := valor;

    valor := valor + 1;
  hasta 1=0;
  devuelve 0;
fin


// Devuelve la cantidad de dígitos de n
funcion digitos(n: entero) : entero
es
  locales
    cont: entero;
  fin
secuencia
  cont := 0;
  repetir
    cont := cont + 1;
    n := n / 10;
  hasta n = 0;
  devuelve cont;
fin


// Escribe el número dado con una anchura de n
funcion ajusta(numero, n: entero) : entero
es
  locales
    copia, espacios, i: entero;
  fin
secuencia
  espacios := n - llama digitos(numero);
  repetir
    salir si espacios <= 0;
    escribe " ";
    espacios := espacios - 1;
  hasta 1=0;
  escribe numero;
  devuelve 0;
fin


// Programa principal
secuencia
  tam := 11;
  aux := llama crea_cuadrado_magico(tam);

  i := 0;
  repetir
    j := 0;
    repetir
      aux := llama ajusta(matriz[i][j], llama digitos(tam*tam)); escribe " ";
      j := j + 1;
    hasta j >= tam;
    nl;
    i := i + 1;
  hasta i >= tam;
fin
