globales
    n, k, resultado1, resultado2 : entero;
fin

funcion Factorial(n : entero ) : entero es
secuencia
    si n = 0 entonces
        devuelve 1;
    si_no
        devuelve llama Factorial(n - 1) * n;
    fin
fin

funcion Combinaciones(n, k : entero) : entero es
secuencia
    si k = 0 entonces
        devuelve 1;
    si_no
        si k = n entonces
            devuelve 1;
        si_no
            devuelve llama Combinaciones(n - 1, k - 1)
                   + llama Combinaciones(n - 1, k);
        fin
    fin
fin


// Devuelve el n-esimo termino de Fibonacci (version recursiva)
funcion Fibonacci_r(n: entero): entero es
secuencia
    si n < 3 entonces
        devuelve 1;
    si_no
        devuelve llama Fibonacci_r(n-2) + llama Fibonacci_r(n-1);
    fin
fin


// Devuelve el n-esimo termino de Fibonacci (version iterativa)
funcion Fibonacci_i(n: entero): entero es
locales
    penultimo, ultimo, numero, i: entero;
fin
secuencia
    penultimo := 0;
    ultimo := 1;
    i := 1;
    repetir
        numero := penultimo + ultimo;
        penultimo := ultimo;
        ultimo := numero;
        i:= i + 1;
    hasta i >= n;
    devuelve ultimo;
fin


secuencia

    n := 0;
    repetir
        k := 0;
        repetir
            resultado1 := llama Combinaciones(n, k);
            resultado2 := llama Factorial(n) / (llama Factorial(k) * llama Factorial(n-k));
            salir si resultado1 != resultado2;
            escribe "Combinaciones(";
            escribe n;
            escribe ",";
            escribe k;
            escribe ") = ";
            escribe resultado1;
            nl;
            k := k + 1;
        hasta k > n;
        resultado1 := llama Fibonacci_i(n);
        resultado2 := llama Fibonacci_r(n);
        salir si resultado1 != resultado2;
        escribe "Fibonacci(";
        escribe n;
        escribe ") = ";
        escribe resultado1;
        nl;
        n := n + 1;
    hasta n > 5;

fin
